; compiler          : jal 0.4.60
; date              : 19-Nov-2006 06:58:33
; main source       : flashled
; command line      : -slib flashled.jal 
; target  chip      : 16f628
;         cpu       : pic 14
;         clock     : 10000000
; input   files     : 12
;         lines     : 2325
;         chars     : 59284
; compilation nodes : 13426
;             stack : 19Kb
;              heap : 4063Kb
;           seconds : 0.296 (7854 lines/second)
; output       code :  207
;              page :    0 (0.0%)
;              bank :    0 (0.0%)
;         page+bank :    0 (0.0%)
;              file :   14
;              stack:    2 (2,0,0)

 errorlevel -306
 list p=PIC16f628

; note: the f628 config is still fixed!
 __CONFIG H'3F10' 
 ORG 0000
  goto    __main
 ORG 0004
 ORG 0004
__interrupt: ; 0004
__main: ; 0004
; var H'020:000'  transfer_bit
; var H'020:000'  transfer_byte

;; 294 : var byte trisa
; var H'021:000' trisa

;; 295 : var byte trisb
; var H'022:000' trisb

;; 302 : trisa = all_input
  movlw   H'FF'
  movwf   H'021'

;; 304 :    trisb = all_input
  movlw   H'FF'
  movwf   H'022'

;; 610 : var byte _port_a_buffer
; var H'023:000' _port_a_buffer

;; 011 : pin_a0_direction = output
  bcf     H'021',0
  call    _3317__vector

;; 012 : pin_a1_direction = output
  bcf     H'021',1
  call    _3346__vector

;; 013 : pin_a2_direction = output
  bcf     H'021',2
  call    _3375__vector

;; 034 : forever loop
w_12709_ag: ; 000E

;; 036 : 	for 3 loop
; var H'024:000' _loop_temp_12579
  movlw   H'03'
  movwf   H'024'
f_12579_again: ; 0010

;; 037 : 		pin_a0 = on
  bsf     H'023',0
  call    _6253__vector

;; 038 : 		pin_a1 = on
  bsf     H'023',1
  call    _6282__vector

;; 039 : 		pin_a2 = on
  bsf     H'023',2
  call    _6311__vector

;; 041 : 		delay_ms( 200 )
  movlw   H'C8'
  call    _12504__vector

;; 043 : 		pin_a0 = off
  bcf     H'023',0
  call    _6253__vector

;; 044 : 		pin_a1 = off
  bcf     H'023',1
  call    _6282__vector

;; 045 : 		pin_a2 = off
  bcf     H'023',2
  call    _6311__vector

;; 047 : 		delay_ms( 200 )
  movlw   H'C8'
  call    _12504__vector

  decfsz  H'024',f
  goto    f_12579_again

;; 050 : 	delay_ms( 200 )
  movlw   H'C8'
  call    _12504__vector

;; 052 : 	for 3 loop
; var H'024:000' _loop_temp_12654
  movlw   H'03'
  movwf   H'024'
f_12654_again: ; 0026

;; 053 : 		pin_a0 = on
  bsf     H'023',0
  call    _6253__vector

;; 054 : 		delay_ms( 50 )
  movlw   H'32'
  call    _12504__vector

;; 055 : 		pin_a0 = off
  bcf     H'023',0
  call    _6253__vector

;; 056 : 		delay_ms( 50 )
  movlw   H'32'
  call    _12504__vector

  decfsz  H'024',f
  goto    f_12654_again

;; 059 : 	delay_sec( 1 )
  movlw   H'01'
  call    _12537__vector
  goto    w_12709_ag

;; 003 :   idle_loop: page goto idle_loop
as_12712_idle_loop: ; 0033
  goto    as_12712_idle_loop
_12537__vector: ; 0034

;; 024 : procedure delay_sec( byte in sec ) is
; var H'024:000' sec
p_12537_delay_sec: ; 0034
  movwf   H'024'

;; 025 : 	for sec loop
; var H'025:000' _loop_temp_12551
  movf    H'024',w
  movwf   H'025'
w_12822_ag: ; 0037
  movf    H'025',f
  btfss   H'003',2
  goto    w_12822_bo
w_12822_jb: ; 003A
  goto    w_12822_be
w_12822_bo: ; 003B

;; 026 : 		for 3 loop
; var H'026:000' _loop_temp_12555
  movlw   H'03'
  movwf   H'026'
f_12555_again: ; 003D

;; 459 : procedure delay_100ms( byte in x = 1 ) is
  movlw   H'01'

;; 027 : 			delay_100ms
  call    _10531__vector

  decfsz  H'026',f
  goto    f_12555_again
  decf    H'025',f
  goto    w_12822_ag
w_12822_be: ; 0043
e_12537_delay_sec: ; 0043
  return  
_12504__vector: ; 0044

;; 018 : procedure delay_ms( byte in millisec ) is
; var H'025:000' millisec
p_12504_delay_ms: ; 0044
  movwf   H'025'

;; 019 : 	for millisec loop
; var H'026:000' _loop_temp_12518
  movf    H'025',w
  movwf   H'026'
w_12786_ag: ; 0047
  movf    H'026',f
  btfss   H'003',2
  goto    w_12786_bo
w_12786_jb: ; 004A
  goto    w_12786_be
w_12786_bo: ; 004B

;; 435 : procedure delay_1ms( byte in x = 1 ) is
  movlw   H'01'

;; 020 : 			delay_1ms
  call    _10261__vector

  decf    H'026',f
  goto    w_12786_ag
w_12786_be: ; 004F
e_12504_delay_ms: ; 004F
  return  
_10531__vector: ; 0050

;; 459 : procedure delay_100ms( byte in x = 1 ) is
; var H'027:000' x
p_10531_delay_100ms: ; 0050
  movwf   H'027'

;; 460 :    _delay_100us( x, 100, 10 )
  movf    H'027',w
  movwf   H'028'
  movlw   H'64'
  movwf   H'029'
  movlw   H'0A'
  goto    _9717__vector
e_10531_delay_100ms: ; 0057
_10261__vector: ; 0057

;; 435 : procedure delay_1ms( byte in x = 1 ) is
; var H'027:000' x
p_10261_delay_1ms: ; 0057
  movwf   H'027'

;; 436 :    _delay_100us( x, 10, 1 )
  movf    H'027',w
  movwf   H'028'
  movlw   H'0A'
  movwf   H'029'
  movlw   H'01'
  goto    _9717__vector
e_10261_delay_1ms: ; 005E
_9717__vector: ; 005E

;; 283 : procedure _delay_100us( byte in x, byte in y, byte in z ) is
; var H'028:000' x
; var H'029:000' y
; var H'02A:000' z
p_9717__delay_100us: ; 005E
  movwf   H'02A'

;; 337 :       var byte minus_one = -1
; var H'02B:000' minus_one
  movlw   H'FFFFFFFF'
  movwf   H'02B'

;; 339 :       var byte xx, yy
; var H'02C:000' xx
; var H'02D:000' yy

;; 343 :          local loop_x, loop_y, loop_z, loop_w
; const H'066' loop_w

;; 346 :       loop_z:
as_9935_loop_z: ; 0061

;; 349 :          movfw y
  movf    H'029',w

;; 350 :          movwf yy
  movwf   H'02D'

;; 351 :       loop_y:
as_9932_loop_y: ; 0063

;; 354 :          movfw x
  movf    H'028',w

;; 355 :          movwf xx
  movwf   H'02C'

;; 356 :       loop_x:
as_9929_loop_x: ; 0065

;; 358 :          movlw inner_iterations
  movlw   H'3B'

;; 360 :       loop_w:
as_9938_loop_w: ; 0066

;; 361 :          addwf minus_one, w
  addwf   H'02B',w

;; 362 :          skpnc
  skpnc   

;; 363 :             goto loop_w
  goto    as_9938_loop_w

;; 366 :          decfsz xx, f
  decfsz  H'02C',f

;; 367 :          goto loop_x
  goto    as_9929_loop_x

;; 370 :          decfsz yy, f
  decfsz  H'02D',f

;; 371 :          goto loop_y
  goto    as_9932_loop_y

;; 374 :          decfsz z, f
  decfsz  H'02A',f

;; 375 :          goto loop_z
  goto    as_9935_loop_z
e_9717__delay_100us: ; 006F
  return  

;; 726 : procedure pin_a2'put( bit in x at _port_a_buffer : 2 ) is
p_6311__pin_a2__put_t: ; 0070
_6311__vector: ; 0070
; var H'023:002' x
p_6311_put: ; 0070

;; 727 :    _port_a_flush
  goto    _5326__vector
e_6311_put: ; 0071

;; 723 : procedure pin_a1'put( bit in x at _port_a_buffer : 1 ) is
p_6282__pin_a1__put_t: ; 0071
_6282__vector: ; 0071
; var H'023:001' x
p_6282_put: ; 0071

;; 724 :    _port_a_flush
  goto    _5326__vector
e_6282_put: ; 0072

;; 720 : procedure pin_a0'put( bit in x at _port_a_buffer : 0 ) is
p_6253__pin_a0__put_t: ; 0072
_6253__vector: ; 0072
; var H'023:000' x
p_6253_put: ; 0072

;; 721 :    _port_a_flush
  goto    _5326__vector
e_6253_put: ; 0073
_5326__vector: ; 0073
p_5326__port_a_flush: ; 0073

;; 617 :    var volatile byte port_a_ at 5 = _port_a_buffer
; var H'005:000' port_a_
  movf    H'023',w
  movwf   H'005'
e_5326__port_a_flush: ; 0075
  return  

;; 391 : procedure pin_a2_direction'put( bit in d at trisa : 2 ) is
p_3375__pin_a2_direction__put_t: ; 0076
_3375__vector: ; 0076
; var H'021:002' d
p_3375_put: ; 0076

;; 392 :    _trisa_flush
  goto    _2925__vector
e_3375_put: ; 0077

;; 388 : procedure pin_a1_direction'put( bit in d at trisa : 1 ) is
p_3346__pin_a1_direction__put_t: ; 0077
_3346__vector: ; 0077
; var H'021:001' d
p_3346_put: ; 0077

;; 389 :    _trisa_flush
  goto    _2925__vector
e_3346_put: ; 0078

;; 385 : procedure pin_a0_direction'put( bit in d at trisa : 0 ) is
p_3317__pin_a0_direction__put_t: ; 0078
_3317__vector: ; 0078
; var H'021:000' d
p_3317_put: ; 0078

;; 386 :    _trisa_flush
  goto    _2925__vector
e_3317_put: ; 0079
_2925__vector: ; 0079
p_2925__trisa_flush: ; 0079

;; 316 :       bank movfw trisa
  movf    H'021',w

;; 317 :            tris  5
  tris    H'005'
e_2925__trisa_flush: ; 007B
  return  

 END

; ********** variable mapping
; 05:0 : ;
;   port_a_                        * 0617:22 lib\jpic.jal 
; 20:0 : ;
;    transfer_byte                   
;    transfer_bit                    
; 21:0 : ;
;   d                              * 0385:33 lib\jpic.jal 
;   trisa                            0294:10 lib\jpic.jal 
; 21:1 : ;
;   d                              * 0388:33 lib\jpic.jal 
; 21:2 : ;
;   d                              * 0391:33 lib\jpic.jal 
; 22:0 : ;
;   trisb                            0295:10 lib\jpic.jal 
; 23:0 : ;
;   x                              * 0720:23 lib\jpic.jal 
;   _port_a_buffer                   0610:10 lib\jpic.jal 
; 23:1 : ;
;   x                              * 0723:23 lib\jpic.jal 
; 23:2 : ;
;   x                              * 0726:23 lib\jpic.jal 
; 24:0 : ;
;   sec                              0024:22 flashled.jal 
;   _loop_temp_12654                 0052:02 flashled.jal 
;   _loop_temp_12579                 0036:02 flashled.jal 
; 25:0 : ;
;   millisec                         0018:21 flashled.jal 
;   _loop_temp_12551                 0025:02 flashled.jal 
; 26:0 : ;
;   _loop_temp_12518                 0019:02 flashled.jal 
;   _loop_temp_12555                 0026:03 flashled.jal 
; 27:0 : ;
;   x                                0435:22 lib\jdelay.jal 
;   x                                0459:24 lib\jdelay.jal 
; 28:0 : ;
;   x                                0283:25 lib\jdelay.jal 
; 29:0 : ;
;   y                                0283:36 lib\jdelay.jal 
; 2A:0 : ;
;   z                                0283:47 lib\jdelay.jal 
; 2B:0 : ;
;   minus_one                        0337:16 lib\jdelay.jal 
; 2C:0 : ;
;   xx                               0339:16 lib\jdelay.jal 
; 2D:0 : ;
;   yy                               0339:20 lib\jdelay.jal 

